﻿#region Usings
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Windows.UI.Popups;
#endregion

using Windows.Devices.Sms;
using Windows.Devices.Enumeration;

namespace CodeSnippets
{
    public sealed partial class MainPage : CodeSnippets.Common.LayoutAwarePage
    {
        MessageDialog testDialog;
        String text;
        SmsDevice myDevice;

        public MainPage()
        {
            this.InitializeComponent();
            myDevice.SmsMessageReceived += myDevice_SmsMessageReceived;
            myDevice.SmsDeviceStatusChanged += myDevice_SmsDeviceStatusChanged;
        }

        async void myDevice_SmsDeviceStatusChanged(SmsDevice sender)
        {
            testDialog = new MessageDialog(sender.DeviceStatus.ToString());
            await testDialog.ShowAsync();
        }

        void myDevice_SmsMessageReceived(SmsDevice sender, SmsMessageReceivedEventArgs e)
        {
            throw new NotImplementedException();
        }

        private async void InizializzazioneDefault_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                myDevice = await SmsDevice.GetDefaultAsync();
                text = String.Format("Account number: {0}\nDevice status: {1}\nCellular Class: {2}\nMessage store max size: {3}", myDevice.AccountPhoneNumber, myDevice.DeviceStatus, myDevice.CellularClass, myDevice.MessageStore.MaxMessages);
                testDialog = new MessageDialog(text, "Mobile Broadband Device Informations");
                await testDialog.ShowAsync();
            }
            catch (Exception ex)
            {
                /***
                 * hResult : E_ACCESSDENIED (0x80007005) -2147024891
                 * hResult : Servizio non avviato (0x80070426) -2147023834
                ***/
                ShowError(ex.HResult);
            }
        }

        private async void Enumerazione_Click(object sender, RoutedEventArgs e)
        {
            DeviceInformationCollection bbdEnumeration = await DeviceInformation.FindAllAsync(SmsDevice.GetDeviceSelector());

            foreach (DeviceInformation item in bbdEnumeration)
            {
                try
                {
                    myDevice = await SmsDevice.FromIdAsync(item.Id);
                    text = String.Format("Account number: {0}\nDevice status: {1}\nCellular Class: {2}\nMessage store max size: {3}", myDevice.AccountPhoneNumber, myDevice.DeviceStatus, myDevice.CellularClass, myDevice.MessageStore.MaxMessages);
                    testDialog = new MessageDialog(text, "Mobile Broadband Device Informations");
                    await testDialog.ShowAsync();
                }
                catch (Exception ex)
                {
                    ShowError(ex.HResult);
                }
            }

        }

        private async void Invio_Click(object sender, RoutedEventArgs e)
        {
            SmsTextMessage msg = new SmsTextMessage();
            msg.To = "555-0123";
            msg.Body = "Message sent during #WIN811";

            await myDevice.SendMessageAsync(msg);
        }

        private async void LetturaStore_Click(object sender, RoutedEventArgs e)
        {
            IReadOnlyList<ISmsMessage> list = await myDevice.MessageStore.GetMessagesAsync(SmsMessageFilter.All);
            foreach (SmsBinaryMessage item in list)
            {
                SmsTextMessage sms = SmsTextMessage.FromBinaryMessage(item);
                // Facciamo qualcosa per mostrare in output i messaggi
            }
        }

        private async void Rimozione_Click(object sender, RoutedEventArgs e)
        {
            IReadOnlyList<ISmsMessage> list = await myDevice.MessageStore.GetMessagesAsync(SmsMessageFilter.All);
            await myDevice.MessageStore.DeleteMessagesAsync(SmsMessageFilter.Read);
            await myDevice.MessageStore.DeleteMessageAsync(list[0].Id);
        }

        // Error handling function
        private async void ShowError(Int32 text)
        {
            MessageDialog erro = new MessageDialog(string.Format("{0}", text), "hResult code:");
            await erro.ShowAsync();
        }
    }
}